## GtkTextView

GtkTextView — Widget that displays a GtkTextBuffer

## Functions

GtkWidget * | gtk_text_view_new ()
GtkWidget * | gtk_text_view_new_with_buffer ()
void | gtk_text_view_set_buffer ()
GtkTextBuffer * | gtk_text_view_get_buffer ()
GtkAdjustment * | gtk_text_view_get_hadjustment ()
GtkAdjustment * | gtk_text_view_get_vadjustment ()
void | gtk_text_view_scroll_to_mark ()
gboolean | gtk_text_view_scroll_to_iter ()
void | gtk_text_view_scroll_mark_onscreen ()
gboolean | gtk_text_view_move_mark_onscreen ()
gboolean | gtk_text_view_place_cursor_onscreen ()
void | gtk_text_view_get_visible_rect ()
void | gtk_text_view_get_iter_location ()
void | gtk_text_view_get_cursor_locations ()
void | gtk_text_view_get_line_at_y ()
void | gtk_text_view_get_line_yrange ()
void | gtk_text_view_get_iter_at_location ()
void | gtk_text_view_get_iter_at_position ()
void | gtk_text_view_buffer_to_window_coords ()
void | gtk_text_view_window_to_buffer_coords ()
GdkWindow * | gtk_text_view_get_window ()
GtkTextWindowType | gtk_text_view_get_window_type ()
void | gtk_text_view_set_border_window_size ()
gint | gtk_text_view_get_border_window_size ()
gboolean | gtk_text_view_forward_display_line ()
gboolean | gtk_text_view_backward_display_line ()
gboolean | gtk_text_view_forward_display_line_end ()
gboolean | gtk_text_view_backward_display_line_start ()
gboolean | gtk_text_view_starts_display_line ()
gboolean | gtk_text_view_move_visually ()
void | gtk_text_view_add_child_at_anchor ()
GtkTextChildAnchor * | gtk_text_child_anchor_new ()
GList * | gtk_text_child_anchor_get_widgets ()
gboolean | gtk_text_child_anchor_get_deleted ()
void | gtk_text_view_add_child_in_window ()
void | gtk_text_view_move_child ()
void | gtk_text_view_set_wrap_mode ()
GtkWrapMode | gtk_text_view_get_wrap_mode ()
void | gtk_text_view_set_editable ()
gboolean | gtk_text_view_get_editable ()
void | gtk_text_view_set_cursor_visible ()
gboolean | gtk_text_view_get_cursor_visible ()
void | gtk_text_view_set_overwrite ()
gboolean | gtk_text_view_get_overwrite ()
void | gtk_text_view_set_pixels_above_lines ()
gint | gtk_text_view_get_pixels_above_lines ()
void | gtk_text_view_set_pixels_below_lines ()
gint | gtk_text_view_get_pixels_below_lines ()
void | gtk_text_view_set_pixels_inside_wrap ()
gint | gtk_text_view_get_pixels_inside_wrap ()
void | gtk_text_view_set_justification ()
GtkJustification | gtk_text_view_get_justification ()
void | gtk_text_view_set_left_margin ()
gint | gtk_text_view_get_left_margin ()
void | gtk_text_view_set_right_margin ()
gint | gtk_text_view_get_right_margin ()
void | gtk_text_view_set_top_margin ()
gint | gtk_text_view_get_top_margin ()
void | gtk_text_view_set_bottom_margin ()
gint | gtk_text_view_get_bottom_margin ()
void | gtk_text_view_set_indent ()
gint | gtk_text_view_get_indent ()
void | gtk_text_view_set_tabs ()
PangoTabArray * | gtk_text_view_get_tabs ()
void | gtk_text_view_set_accepts_tab ()
gboolean | gtk_text_view_get_accepts_tab ()
GtkTextAttributes * | gtk_text_view_get_default_attributes ()
gboolean | gtk_text_view_im_context_filter_keypress ()
void | gtk_text_view_reset_im_context ()
void | gtk_text_view_set_input_purpose ()
GtkInputPurpose | gtk_text_view_get_input_purpose ()
void | gtk_text_view_set_input_hints ()
GtkInputHints | gtk_text_view_get_input_hints ()
void | gtk_text_view_set_monospace ()
gboolean | gtk_text_view_get_monospace ()

## Properties

gboolean | accepts-tab | Read / Write
gint | bottom-margin | Read / Write
GtkTextBuffer * | buffer | Read / Write
gboolean | cursor-visible | Read / Write
gboolean | editable | Read / Write
gchar * | im-module | Read / Write
gint | indent | Read / Write
GtkInputHints | input-hints | Read / Write
GtkInputPurpose | input-purpose | Read / Write
GtkJustification | justification | Read / Write
gint | left-margin | Read / Write
gboolean | monospace | Read / Write
gboolean | overwrite | Read / Write
gint | pixels-above-lines | Read / Write
gint | pixels-below-lines | Read / Write
gint | pixels-inside-wrap | Read / Write
gboolean | populate-all | Read / Write
gint | right-margin | Read / Write
PangoTabArray * | tabs | Read / Write
gint | top-margin | Read / Write
GtkWrapMode | wrap-mode | Read / Write

## Style Properties

GdkColor * | error-underline-color | Read

## Signals

void | backspace | Action
void | copy-clipboard | Action
void | cut-clipboard | Action
void | delete-from-cursor | Action
gboolean | extend-selection | Run Last
void | insert-at-cursor | Action
void | move-cursor | Action
void | move-viewport | Action
void | paste-clipboard | Action
void | populate-popup | Run Last
void | preedit-changed | Action
void | select-all | Action
void | set-anchor | Action
void | toggle-cursor-visible | Action
void | toggle-overwrite | Action

## Types and Values

struct | GtkTextView
struct | GtkTextViewClass
enum | GtkTextViewLayer
enum | GtkTextWindowType
enum | GtkTextExtendSelection
enum | GtkWrapMode
struct | GtkTextChildAnchor
#define | GTK_TEXT_VIEW_PRIORITY_VALIDATE

## Object Hierarchy

        GObject
        ├── GInitiallyUnowned
        │   ╰── GtkWidget
        │       ╰── GtkContainer
        │           ╰── GtkTextView
        ╰── GtkTextChildAnchor

## Implemented Interfaces

GtkTextView implements AtkImplementorIface, GtkBuildable and GtkScrollable.

## Includes

    #include <gtk/gtk.h>

## Description

You may wish to begin by reading the text widget conceptual overview which gives an overview of all the objects and data types related to the text widget and how they work together.

## Functions

### gtk_text_view_new ()

    GtkWidget *
    gtk_text_view_new (void);

Creates a new GtkTextView. If you don’t call `gtk_text_view_set_buffer()` before using the text view, an empty default buffer will be created for you. Get the buffer with `gtk_text_view_get_buffer()`. If you want to specify your own buffer, consider `gtk_text_view_new_with_buffer()`.

#### Returns

a new GtkTextView

### gtk_text_view_new_with_buffer ()

    GtkWidget *
    gtk_text_view_new_with_buffer (GtkTextBuffer *buffer);

Creates a new GtkTextView widget displaying the buffer `buffer` . One buffer can be shared among many widgets. `buffer` may be `NULL` to create a default buffer, in which case this function is equivalent to `gtk_text_view_new()`. The text view adds its own reference count to the buffer; it does not take over an existing reference.

#### Parameters

buffer | a GtkTextBuffer |

#### Returns

a new GtkTextView.

### gtk_text_view_set_buffer ()

    void
    gtk_text_view_set_buffer (GtkTextView *text_view,
                              GtkTextBuffer *buffer);

Sets `buffer` as the buffer being displayed by `text_view` . The previous buffer displayed by the text view is unreferenced, and a reference is added to `buffer` . If you owned a reference to `buffer` before passing it to this function, you must remove that reference yourself; GtkTextView will not “adopt” it.

#### Parameters

text_view | a GtkTextView |
buffer | a GtkTextBuffer. | [allow-none]

### gtk_text_view_get_buffer ()

    GtkTextBuffer *
    gtk_text_view_get_buffer (GtkTextView *text_view);

Returns the GtkTextBuffer being displayed by this text view. The reference count on the buffer is not incremented; the caller of this function won’t own a new reference.

#### Parameters

text_view | a GtkTextView |

#### Returns

a GtkTextBuffer.

[transfer none]

### gtk_text_view_get_hadjustment ()

    GtkAdjustment *
    gtk_text_view_get_hadjustment (GtkTextView *text_view);

`gtk_text_view_get_hadjustment` has been deprecated since version 3.0 and should not be used in newly-written code.

Use `gtk_scrollable_get_hadjustment()`

Gets the horizontal-scrolling GtkAdjustment.

#### Parameters

text_view | a GtkTextView |

#### Returns

pointer to the horizontal GtkAdjustment.

[transfer none]

Since: 2.22

### gtk_text_view_get_vadjustment ()

    GtkAdjustment *
    gtk_text_view_get_vadjustment (GtkTextView *text_view);

`gtk_text_view_get_vadjustment` has been deprecated since version 3.0 and should not be used in newly-written code.

Use `gtk_scrollable_get_vadjustment()`

Gets the vertical-scrolling GtkAdjustment.

#### Parameters

text_view | a GtkTextView |

#### Returns

pointer to the vertical GtkAdjustment.

[transfer none]

Since: 2.22

### gtk_text_view_scroll_to_mark ()

    void
    gtk_text_view_scroll_to_mark (GtkTextView *text_view,
                                  GtkTextMark *mark,
                                  gdouble within_margin,
                                  gboolean use_align,
                                  gdouble xalign,
                                  gdouble yalign);

Scrolls `text_view` so that `mark` is on the screen in the position indicated by `xalign` and `yalign` . An alignment of 0.0 indicates left or top, 1.0 indicates right or bottom, 0.5 means center. If `use_align` is `FALSE`, the text scrolls the minimal distance to get the mark onscreen, possibly not scrolling at all. The effective screen for purposes of this function is reduced by a margin of size `within_margin` .

#### Parameters

text_view | a GtkTextView |
mark | a GtkTextMark |
within_margin | margin as a [0.0,0.5) fraction of screen size |
use_align | whether to use alignment arguments (if `FALSE`, just get the mark onscreen) |
xalign | horizontal alignment of mark within visible area |
yalign | vertical alignment of mark within visible area |

### gtk_text_view_scroll_to_iter ()

    gboolean
    gtk_text_view_scroll_to_iter (GtkTextView *text_view,
                                  GtkTextIter *iter,
                                  gdouble within_margin,
                                  gboolean use_align,
                                  gdouble xalign,
                                  gdouble yalign);

Scrolls `text_view` so that `iter` is on the screen in the position indicated by `xalign` and `yalign` . An alignment of 0.0 indicates left or top, 1.0 indicates right or bottom, 0.5 means center. If `use_align` is `FALSE`, the text scrolls the minimal distance to get the mark onscreen, possibly not scrolling at all. The effective screen for purposes of this function is reduced by a margin of size `within_margin` .

Note that this function uses the currently-computed height of the lines in the text buffer. Line heights are computed in an idle handler; so this function may not have the desired effect if it’s called before the height computations. To avoid oddness, consider using `gtk_text_view_scroll_to_mark()` which saves a point to be scrolled to after line validation.

#### Parameters

text_view | a GtkTextView |
iter | a GtkTextIter |
within_margin | margin as a [0.0,0.5) fraction of screen size |
use_align | whether to use alignment arguments (if `FALSE`, just get the mark onscreen) |
xalign | horizontal alignment of mark within visible area |
yalign | vertical alignment of mark within visible area |

#### Returns

`TRUE` if scrolling occurred

### gtk_text_view_scroll_mark_onscreen ()

    void
    gtk_text_view_scroll_mark_onscreen (GtkTextView *text_view,
                                        GtkTextMark *mark);

Scrolls `text_view` the minimum distance such that `mark` is contained within the visible area of the widget.

#### Parameters

text_view | a GtkTextView |
mark | a mark in the buffer for `text_view` |

### gtk_text_view_move_mark_onscreen ()

    gboolean
    gtk_text_view_move_mark_onscreen (GtkTextView *text_view,
                                      GtkTextMark *mark);

Moves a mark within the buffer so that it's located within the currently-visible text area.

#### Parameters

text_view | a GtkTextView |
mark | a GtkTextMark |

#### Returns

`TRUE` if the mark moved (wasn’t already onscreen)

### gtk_text_view_place_cursor_onscreen ()

    gboolean
    gtk_text_view_place_cursor_onscreen (GtkTextView *text_view);

Moves the cursor to the currently visible region of the buffer, it it isn’t there already.

#### Parameters

text_view | a GtkTextView |

#### Returns

`TRUE` if the cursor had to be moved.

### gtk_text_view_get_visible_rect ()

    void
    gtk_text_view_get_visible_rect (GtkTextView *text_view,
                                    GdkRectangle *visible_rect);

Fills `visible_rect` with the currently-visible region of the buffer, in buffer coordinates. Convert to window coordinates with `gtk_text_view_buffer_to_window_coords()`.

#### Parameters

text_view | a GtkTextView |
visible_rect | rectangle to fill. | [out]

### gtk_text_view_get_iter_location ()

    void
    gtk_text_view_get_iter_location (GtkTextView *text_view,
                                     const GtkTextIter *iter,
                                     GdkRectangle *location);

Gets a rectangle which roughly contains the character at `iter` . The rectangle position is in buffer coordinates; use `gtk_text_view_buffer_to_window_coords()` to convert these coordinates to coordinates for one of the windows in the text view.

#### Parameters

text_view | a GtkTextView |
iter | a GtkTextIter |
location | bounds of the character at `iter` . | [out]

### gtk_text_view_get_cursor_locations ()

    void
    gtk_text_view_get_cursor_locations (GtkTextView *text_view,
                                        const GtkTextIter *iter,
                                        GdkRectangle *strong,
                                        GdkRectangle *weak);

Given an `iter` within a text layout, determine the positions of the strong and weak cursors if the insertion point is at that iterator. The position of each cursor is stored as a zero-width rectangle. The strong cursor location is the location where characters of the directionality equal to the base direction of the paragraph are inserted. The weak cursor location is the location where characters of the directionality opposite to the base direction of the paragraph are inserted.

If `iter` is `NULL`, the actual cursor position is used.

Note that if `iter` happens to be the actual cursor position, and there is currently an IM preedit sequence being entered, the returned locations will be adjusted to account for the preedit cursor’s offset within the preedit sequence.

The rectangle position is in buffer coordinates; use `gtk_text_view_buffer_to_window_coords()` to convert these coordinates to coordinates for one of the windows in the text view.

#### Parameters

text_view | a GtkTextView |
iter | a GtkTextIter. | [allow-none]
strong | location to store the strong cursor position (may be `NULL`). | [out][allow-none]
weak | location to store the weak cursor position (may be `NULL`). | [out][allow-none]

Since: 3.0

### gtk_text_view_get_line_at_y ()

    void
    gtk_text_view_get_line_at_y (GtkTextView *text_view,
                                 GtkTextIter *target_iter,
                                 gint y,
                                 gint *line_top);

Gets the GtkTextIter at the start of the line containing the coordinate `y` . `y` is in buffer coordinates, convert from window coordinates with `gtk_text_view_window_to_buffer_coords()`. If non-`NULL`, `line_top` will be filled with the coordinate of the top edge of the line.

#### Parameters

text_view | a GtkTextView |
target_iter | a GtkTextIter. | [out]
y | a y coordinate |
line_top | return location for top coordinate of the line. | [out]

### gtk_text_view_get_line_yrange ()

    void
    gtk_text_view_get_line_yrange (GtkTextView *text_view,
                                   const GtkTextIter *iter,
                                   gint *y,
                                   gint *height);

Gets the y coordinate of the top of the line containing `iter` , and the height of the line. The coordinate is a buffer coordinate; convert to window coordinates with `gtk_text_view_buffer_to_window_coords()`.

#### Parameters

text_view | a GtkTextView |
iter | a GtkTextIter |
y | return location for a y coordinate. | [out]
height | return location for a height. | [out]

### gtk_text_view_get_iter_at_location ()

    void
    gtk_text_view_get_iter_at_location (GtkTextView *text_view,
                                        GtkTextIter *iter,
                                        gint x,
                                        gint y);

Retrieves the iterator at buffer coordinates `x` and `y` . Buffer coordinates are coordinates for the entire buffer, not just the currently-displayed portion. If you have coordinates from an event, you have to convert those to buffer coordinates with `gtk_text_view_window_to_buffer_coords()`.

#### Parameters

text_view | a GtkTextView |
iter | a GtkTextIter. | [out]
x | x position, in buffer coordinates |
y | y position, in buffer coordinates |

### gtk_text_view_get_iter_at_position ()

    void
    gtk_text_view_get_iter_at_position (GtkTextView *text_view,
                                        GtkTextIter *iter,
                                        gint *trailing,
                                        gint x,
                                        gint y);

Retrieves the iterator pointing to the character at buffer coordinates `x` and `y` . Buffer coordinates are coordinates for the entire buffer, not just the currently-displayed portion. If you have coordinates from an event, you have to convert those to buffer coordinates with `gtk_text_view_window_to_buffer_coords()`.

Note that this is different from `gtk_text_view_get_iter_at_location()`, which returns cursor locations, i.e. positions between characters.

#### Parameters

text_view | a GtkTextView |
iter | a GtkTextIter. | [out]
trailing | if non-`NULL`, location to store an integer indicating where in the grapheme the user clicked. It will either be zero, or the number of characters in the grapheme. 0 represents the trailing edge of the grapheme. | [out][allow-none]
x | x position, in buffer coordinates |
y | y position, in buffer coordinates |

Since: 2.6

### gtk_text_view_buffer_to_window_coords ()

    void
    gtk_text_view_buffer_to_window_coords (GtkTextView *text_view,
                                           GtkTextWindowType win,
                                           gint buffer_x,
                                           gint buffer_y,
                                           gint *window_x,
                                           gint *window_y);

Converts coordinate (`buffer_x` , `buffer_y` ) to coordinates for the window `win` , and stores the result in (`window_x` , `window_y` ).

Note that you can’t convert coordinates for a nonexisting window (see `gtk_text_view_set_border_window_size()`).

#### Parameters

text_view | a GtkTextView |
win | a GtkTextWindowType except GTK_TEXT_WINDOW_PRIVATE |
buffer_x | buffer x coordinate |
buffer_y | buffer y coordinate |
window_x | window x coordinate return location or `NULL`. | [out][allow-none]
window_y | window y coordinate return location or `NULL`. | [out][allow-none]

### gtk_text_view_window_to_buffer_coords ()

    void
    gtk_text_view_window_to_buffer_coords (GtkTextView *text_view,
                                           GtkTextWindowType win,
                                           gint window_x,
                                           gint window_y,
                                           gint *buffer_x,
                                           gint *buffer_y);

Converts coordinates on the window identified by `win` to buffer coordinates, storing the result in (`buffer_x` ,`buffer_y` ).

Note that you can’t convert coordinates for a nonexisting window (see `gtk_text_view_set_border_window_size()`).

#### Parameters

text_view | a GtkTextView |
win | a GtkTextWindowType except GTK_TEXT_WINDOW_PRIVATE |
window_x | window x coordinate |
window_y | window y coordinate |
buffer_x | buffer x coordinate return location or `NULL`. | [out][allow-none]
buffer_y | buffer y coordinate return location or `NULL`. | [out][allow-none]

### gtk_text_view_get_window ()

    GdkWindow *
    gtk_text_view_get_window (GtkTextView *text_view,
                              GtkTextWindowType win);

Retrieves the GdkWindow corresponding to an area of the text view; possible windows include the overall widget window, child windows on the left, right, top, bottom, and the window that displays the text buffer. Windows are `NULL` and nonexistent if their width or height is 0, and are nonexistent before the widget has been realized.

#### Parameters

text_view | a GtkTextView |
win | window to get |

#### Returns

a GdkWindow, or `NULL`.

[transfer none]

### gtk_text_view_get_window_type ()

    GtkTextWindowType
    gtk_text_view_get_window_type (GtkTextView *text_view,
                                   GdkWindow *window);

Usually used to find out which window an event corresponds to. If you connect to an event signal on `text_view` , this function should be called on `event->window` to see which window it was.

#### Parameters

text_view | a GtkTextView |
window | a window type |

#### Returns

the window type.

### gtk_text_view_set_border_window_size ()

    void
    gtk_text_view_set_border_window_size (GtkTextView *text_view,
                                          GtkTextWindowType type,
                                          gint size);

Sets the width of `GTK_TEXT_WINDOW_LEFT` or `GTK_TEXT_WINDOW_RIGHT`, or the height of `GTK_TEXT_WINDOW_TOP` or `GTK_TEXT_WINDOW_BOTTOM`. Automatically destroys the corresponding window if the size is set to 0, and creates the window if the size is set to non-zero. This function can only be used for the “border windows,” it doesn’t work with GTK_TEXT_WINDOW_WIDGET, GTK_TEXT_WINDOW_TEXT, or GTK_TEXT_WINDOW_PRIVATE.

#### Parameters

text_view | a GtkTextView |
type | window to affect |
size | width or height of the window |

### gtk_text_view_get_border_window_size ()

    gint
    gtk_text_view_get_border_window_size (GtkTextView *text_view,
                                          GtkTextWindowType type);

Gets the width of the specified border window. See `gtk_text_view_set_border_window_size()`.

#### Parameters

text_view | a GtkTextView |
type | window to return size from |

#### Returns

width of window

### gtk_text_view_forward_display_line ()

    gboolean
    gtk_text_view_forward_display_line (GtkTextView *text_view,
                                        GtkTextIter *iter);

Moves the given `iter` forward by one display (wrapped) line. A display line is different from a paragraph. Paragraphs are separated by newlines or other paragraph separator characters. Display lines are created by line-wrapping a paragraph. If wrapping is turned off, display lines and paragraphs will be the same. Display lines are divided differently for each view, since they depend on the view’s width; paragraphs are the same in all views, since they depend on the contents of the GtkTextBuffer.

#### Parameters

text_view | a GtkTextView |
iter | a GtkTextIter |

#### Returns

`TRUE` if `iter` was moved and is not on the end iterator

### gtk_text_view_backward_display_line ()

    gboolean
    gtk_text_view_backward_display_line (GtkTextView *text_view,
                                         GtkTextIter *iter);

Moves the given `iter` backward by one display (wrapped) line. A display line is different from a paragraph. Paragraphs are separated by newlines or other paragraph separator characters. Display lines are created by line-wrapping a paragraph. If wrapping is turned off, display lines and paragraphs will be the same. Display lines are divided differently for each view, since they depend on the view’s width; paragraphs are the same in all views, since they depend on the contents of the GtkTextBuffer.

#### Parameters

text_view | a GtkTextView |
iter | a GtkTextIter |

#### Returns

`TRUE` if `iter` was moved and is not on the end iterator

### gtk_text_view_forward_display_line_end ()

    gboolean
    gtk_text_view_forward_display_line_end
                                   (GtkTextView *text_view,
                                    GtkTextIter *iter);

Moves the given `iter` forward to the next display line end. A display line is different from a paragraph. Paragraphs are separated by newlines or other paragraph separator characters. Display lines are created by line-wrapping a paragraph. If wrapping is turned off, display lines and paragraphs will be the same. Display lines are divided differently for each view, since they depend on the view’s width; paragraphs are the same in all views, since they depend on the contents of the GtkTextBuffer.

#### Parameters

text_view | a GtkTextView |
iter | a GtkTextIter |

#### Returns

`TRUE` if `iter` was moved and is not on the end iterator

### gtk_text_view_backward_display_line_start ()

    gboolean
    gtk_text_view_backward_display_line_start
                                   (GtkTextView *text_view,
                                    GtkTextIter *iter);

Moves the given `iter` backward to the next display line start. A display line is different from a paragraph. Paragraphs are separated by newlines or other paragraph separator characters. Display lines are created by line-wrapping a paragraph. If wrapping is turned off, display lines and paragraphs will be the same. Display lines are divided differently for each view, since they depend on the view’s width; paragraphs are the same in all views, since they depend on the contents of the GtkTextBuffer.

#### Parameters

text_view | a GtkTextView |
iter | a GtkTextIter |

#### Returns

`TRUE` if `iter` was moved and is not on the end iterator

### gtk_text_view_starts_display_line ()

    gboolean
    gtk_text_view_starts_display_line (GtkTextView *text_view,
                                       const GtkTextIter *iter);

Determines whether `iter` is at the start of a display line. See `gtk_text_view_forward_display_line()` for an explanation of display lines vs. paragraphs.

#### Parameters

text_view | a GtkTextView |
iter | a GtkTextIter |

#### Returns

`TRUE` if `iter` begins a wrapped line

### gtk_text_view_move_visually ()

    gboolean
    gtk_text_view_move_visually (GtkTextView *text_view,
                                 GtkTextIter *iter,
                                 gint count);

Move the iterator a given number of characters visually, treating it as the strong cursor position. If `count` is positive, then the new strong cursor position will be `count` positions to the right of the old cursor position. If `count` is negative then the new strong cursor position will be `count` positions to the left of the old cursor position.

In the presence of bi-directional text, the correspondence between logical and visual order will depend on the direction of the current run, and there may be jumps when the cursor is moved off of the end of a run.

#### Parameters

text_view | a GtkTextView |
iter | a GtkTextIter |
count | number of characters to move (negative moves left, positive moves right) |

#### Returns

`TRUE` if `iter` moved and is not on the end iterator

### gtk_text_view_add_child_at_anchor ()

    void
    gtk_text_view_add_child_at_anchor (GtkTextView *text_view,
                                       GtkWidget *child,
                                       GtkTextChildAnchor *anchor);

Adds a child widget in the text buffer, at the given `anchor` .

#### Parameters

text_view | a GtkTextView |
child | a GtkWidget |
anchor | a GtkTextChildAnchor in the GtkTextBuffer for `text_view` |

### gtk_text_child_anchor_new ()

    GtkTextChildAnchor *
    gtk_text_child_anchor_new (void);

Creates a new GtkTextChildAnchor. Usually you would then insert it into a GtkTextBuffer with `gtk_text_buffer_insert_child_anchor()`. To perform the creation and insertion in one step, use the convenience function `gtk_text_buffer_create_child_anchor()`.

#### Returns

a new GtkTextChildAnchor

### gtk_text_child_anchor_get_widgets ()

    GList *
    gtk_text_child_anchor_get_widgets (GtkTextChildAnchor *anchor);

Gets a list of all widgets anchored at this child anchor. The returned list should be freed with `g_list_free()`.

#### Parameters

anchor | a GtkTextChildAnchor |

#### Returns

list of widgets anchored at `anchor` .

[element-type GtkWidget][transfer container]

### gtk_text_child_anchor_get_deleted ()

    gboolean
    gtk_text_child_anchor_get_deleted (GtkTextChildAnchor *anchor);

Determines whether a child anchor has been deleted from the buffer. Keep in mind that the child anchor will be unreferenced when removed from the buffer, so you need to hold your own reference (with `g_object_ref()`) if you plan to use this function — otherwise all deleted child anchors will also be finalized.

#### Parameters

anchor | a GtkTextChildAnchor |

#### Returns

`TRUE` if the child anchor has been deleted from its buffer

### gtk_text_view_add_child_in_window ()

    void
    gtk_text_view_add_child_in_window (GtkTextView *text_view,
                                       GtkWidget *child,
                                       GtkTextWindowType which_window,
                                       gint xpos,
                                       gint ypos);

Adds a child at fixed coordinates in one of the text widget's windows.

The window must have nonzero size (see `gtk_text_view_set_border_window_size()`). Note that the child coordinates are given relative to scrolling. When placing a child in GTK_TEXT_WINDOW_WIDGET, scrolling is irrelevant, the child floats above all scrollable areas. But when placing a child in one of the scrollable windows (border windows or text window) it will move with the scrolling as needed.

#### Parameters

text_view | a GtkTextView |
child | a GtkWidget |
which_window | which window the child should appear in |
xpos | X position of child in window coordinates |
ypos | Y position of child in window coordinates |

### gtk_text_view_move_child ()

    void
    gtk_text_view_move_child (GtkTextView *text_view,
                              GtkWidget *child,
                              gint xpos,
                              gint ypos);

Updates the position of a child, as for `gtk_text_view_add_child_in_window()`.

#### Parameters

text_view | a GtkTextView |
child | child widget already added to the text view |
xpos | new X position in window coordinates |
ypos | new Y position in window coordinates |

### gtk_text_view_set_wrap_mode ()

    void
    gtk_text_view_set_wrap_mode (GtkTextView *text_view,
                                 GtkWrapMode wrap_mode);

Sets the line wrapping for the view.

#### Parameters

text_view | a GtkTextView |
wrap_mode | a GtkWrapMode |

### gtk_text_view_get_wrap_mode ()

    GtkWrapMode
    gtk_text_view_get_wrap_mode (GtkTextView *text_view);

Gets the line wrapping for the view.

#### Parameters

text_view | a GtkTextView |

#### Returns

the line wrap setting

### gtk_text_view_set_editable ()

    void
    gtk_text_view_set_editable (GtkTextView *text_view,
                                gboolean setting);

Sets the default editability of the GtkTextView. You can override this default setting with tags in the buffer, using the “editable” attribute of tags.

#### Parameters

text_view | a GtkTextView |
setting | whether it’s editable |

### gtk_text_view_get_editable ()

    gboolean
    gtk_text_view_get_editable (GtkTextView *text_view);

Returns the default editability of the GtkTextView. Tags in the buffer may override this setting for some ranges of text.

#### Parameters

text_view | a GtkTextView |

#### Returns

whether text is editable by default

### gtk_text_view_set_cursor_visible ()

    void
    gtk_text_view_set_cursor_visible (GtkTextView *text_view,
                                      gboolean setting);

Toggles whether the insertion point is displayed. A buffer with no editable text probably shouldn’t have a visible cursor, so you may want to turn the cursor off.

#### Parameters

text_view | a GtkTextView |
setting | whether to show the insertion cursor |

### gtk_text_view_get_cursor_visible ()

    gboolean
    gtk_text_view_get_cursor_visible (GtkTextView *text_view);

Find out whether the cursor is being displayed.

#### Parameters

text_view | a GtkTextView |

#### Returns

whether the insertion mark is visible

### gtk_text_view_set_overwrite ()

    void
    gtk_text_view_set_overwrite (GtkTextView *text_view,
                                 gboolean overwrite);

Changes the GtkTextView overwrite mode.

#### Parameters

text_view | a GtkTextView |
overwrite | `TRUE` to turn on overwrite mode, `FALSE` to turn it off |

Since: 2.4

### gtk_text_view_get_overwrite ()

    gboolean
    gtk_text_view_get_overwrite (GtkTextView *text_view);

Returns whether the GtkTextView is in overwrite mode or not.

#### Parameters

text_view | a GtkTextView |

#### Returns

whether `text_view` is in overwrite mode or not.

Since: 2.4

### gtk_text_view_set_pixels_above_lines ()

    void
    gtk_text_view_set_pixels_above_lines (GtkTextView *text_view,
                                          gint pixels_above_lines);

Sets the default number of blank pixels above paragraphs in `text_view` . Tags in the buffer for `text_view` may override the defaults.

#### Parameters

text_view | a GtkTextView |
pixels_above_lines | pixels above paragraphs |

### gtk_text_view_get_pixels_above_lines ()

    gint
    gtk_text_view_get_pixels_above_lines (GtkTextView *text_view);

Gets the default number of pixels to put above paragraphs.

#### Parameters

text_view | a GtkTextView |

#### Returns

default number of pixels above paragraphs

### gtk_text_view_set_pixels_below_lines ()

    void
    gtk_text_view_set_pixels_below_lines (GtkTextView *text_view,
                                          gint pixels_below_lines);

Sets the default number of pixels of blank space to put below paragraphs in `text_view` . May be overridden by tags applied to `text_view` ’s buffer.

#### Parameters

text_view | a GtkTextView |
pixels_below_lines | pixels below paragraphs |

### gtk_text_view_get_pixels_below_lines ()

    gint
    gtk_text_view_get_pixels_below_lines (GtkTextView *text_view);

Gets the value set by `gtk_text_view_set_pixels_below_lines()`.

#### Parameters

text_view | a GtkTextView |

#### Returns

default number of blank pixels below paragraphs

### gtk_text_view_set_pixels_inside_wrap ()

    void
    gtk_text_view_set_pixels_inside_wrap (GtkTextView *text_view,
                                          gint pixels_inside_wrap);

Sets the default number of pixels of blank space to leave between display/wrapped lines within a paragraph. May be overridden by tags in `text_view` ’s buffer.

#### Parameters

text_view | a GtkTextView |
pixels_inside_wrap | default number of pixels between wrapped lines |

### gtk_text_view_get_pixels_inside_wrap ()

    gint
    gtk_text_view_get_pixels_inside_wrap (GtkTextView *text_view);

Gets the value set by `gtk_text_view_set_pixels_inside_wrap()`.

#### Parameters

text_view | a GtkTextView |

#### Returns

default number of pixels of blank space between wrapped lines

### gtk_text_view_set_justification ()

    void
    gtk_text_view_set_justification (GtkTextView *text_view,
                                     GtkJustification justification);

Sets the default justification of text in `text_view` . Tags in the view’s buffer may override the default.

#### Parameters

text_view | a GtkTextView |
justification | justification |

### gtk_text_view_get_justification ()

    GtkJustification
    gtk_text_view_get_justification (GtkTextView *text_view);

Gets the default justification of paragraphs in `text_view` . Tags in the buffer may override the default.

#### Parameters

text_view | a GtkTextView |

#### Returns

default justification

### gtk_text_view_set_left_margin ()

    void
    gtk_text_view_set_left_margin (GtkTextView *text_view,
                                   gint left_margin);

Sets the default left margin for text in `text_view` . Tags in the buffer may override the default.

Note that this function is confusingly named. In CSS terms, the value set here is padding.

#### Parameters

text_view | a GtkTextView |
left_margin | left margin in pixels |

### gtk_text_view_get_left_margin ()

    gint
    gtk_text_view_get_left_margin (GtkTextView *text_view);

Gets the default left margin size of paragraphs in the `text_view` . Tags in the buffer may override the default.

#### Parameters

text_view | a GtkTextView |

#### Returns

left margin in pixels

### gtk_text_view_set_right_margin ()

    void
    gtk_text_view_set_right_margin (GtkTextView *text_view,
                                    gint right_margin);

Sets the default right margin for text in the text view. Tags in the buffer may override the default.

Note that this function is confusingly named. In CSS terms, the value set here is padding.

#### Parameters

text_view | a GtkTextView |
right_margin | right margin in pixels |

### gtk_text_view_get_right_margin ()

    gint
    gtk_text_view_get_right_margin (GtkTextView *text_view);

Gets the default right margin for text in `text_view` . Tags in the buffer may override the default.

#### Parameters

text_view | a GtkTextView |

#### Returns

right margin in pixels

### gtk_text_view_set_top_margin ()

    void
    gtk_text_view_set_top_margin (GtkTextView *text_view,
                                  gint top_margin);

Sets the top margin for text in `text_view` .

Note that this function is confusingly named. In CSS terms, the value set here is padding.

#### Parameters

text_view | a GtkTextView |
top_margin | top margin in pixels |

Since: 3.18

### gtk_text_view_get_top_margin ()

    gint
    gtk_text_view_get_top_margin (GtkTextView *text_view);

Gets the top margin for text in the `text_view` .

#### Parameters

text_view | a GtkTextView |

#### Returns

top margin in pixels

Since: 3.18

### gtk_text_view_set_bottom_margin ()

    void
    gtk_text_view_set_bottom_margin (GtkTextView *text_view,
                                     gint bottom_margin);

Sets the bottom margin for text in `text_view` .

Note that this function is confusingly named. In CSS terms, the value set here is padding.

#### Parameters

text_view | a GtkTextView |
bottom_margin | bottom margin in pixels |

Since: 3.18

### gtk_text_view_get_bottom_margin ()

    gint
    gtk_text_view_get_bottom_margin (GtkTextView *text_view);

Gets the bottom margin for text in the `text_view` .

#### Parameters

text_view | a GtkTextView |

#### Returns

bottom margin in pixels

Since: 3.18

### gtk_text_view_set_indent ()

    void
    gtk_text_view_set_indent (GtkTextView *text_view,
                              gint indent);

Sets the default indentation for paragraphs in `text_view` . Tags in the buffer may override the default.

#### Parameters

text_view | a GtkTextView |
indent | indentation in pixels |

### gtk_text_view_get_indent ()

    gint
    gtk_text_view_get_indent (GtkTextView *text_view);

Gets the default indentation of paragraphs in `text_view` . Tags in the view’s buffer may override the default. The indentation may be negative.

#### Parameters

text_view | a GtkTextView |

#### Returns

number of pixels of indentation

### gtk_text_view_set_tabs ()

    void
    gtk_text_view_set_tabs (GtkTextView *text_view,
                            PangoTabArray *tabs);

Sets the default tab stops for paragraphs in `text_view` . Tags in the buffer may override the default.

#### Parameters

text_view | a GtkTextView |
tabs | tabs as a PangoTabArray |

### gtk_text_view_get_tabs ()

    PangoTabArray *
    gtk_text_view_get_tabs (GtkTextView *text_view);

Gets the default tabs for `text_view` . Tags in the buffer may override the defaults. The returned array will be `NULL` if “standard” (8-space) tabs are used. Free the return value with `pango_tab_array_free()`.

#### Parameters

text_view | a GtkTextView |

#### Returns

copy of default tab array, or `NULL` if “standard” tabs are used; must be freed with `pango_tab_array_free()`.

### gtk_text_view_set_accepts_tab ()

    void
    gtk_text_view_set_accepts_tab (GtkTextView *text_view,
                                   gboolean accepts_tab);

Sets the behavior of the text widget when the Tab key is pressed. If `accepts_tab` is `TRUE`, a tab character is inserted. If `accepts_tab` is `FALSE` the keyboard focus is moved to the next widget in the focus chain.

#### Parameters

text_view | A GtkTextView |
accepts_tab | `TRUE` if pressing the Tab key should insert a tab character, `FALSE`, if pressing the Tab key should move the keyboard focus. |

Since: 2.4

### gtk_text_view_get_accepts_tab ()

    gboolean
    gtk_text_view_get_accepts_tab (GtkTextView *text_view);

Returns whether pressing the Tab key inserts a tab characters. `gtk_text_view_set_accepts_tab()`.

#### Parameters

text_view | A GtkTextView |

#### Returns

`TRUE` if pressing the Tab key inserts a tab character, `FALSE` if pressing the Tab key moves the keyboard focus.

Since: 2.4

### gtk_text_view_get_default_attributes ()

    GtkTextAttributes *
    gtk_text_view_get_default_attributes (GtkTextView *text_view);

Obtains a copy of the default text attributes. These are the attributes used for text unless a tag overrides them. You’d typically pass the default attributes in to `gtk_text_iter_get_attributes()` in order to get the attributes in effect at a given text position.

The return value is a copy owned by the caller of this function, and should be freed with `gtk_text_attributes_unref()`.

#### Parameters

text_view | a GtkTextView |

#### Returns

a new GtkTextAttributes

### gtk_text_view_im_context_filter_keypress ()

    gboolean
    gtk_text_view_im_context_filter_keypress
                                   (GtkTextView *text_view,
                                    GdkEventKey *event);

Allow the GtkTextView input method to internally handle key press and release events. If this function returns `TRUE`, then no further processing should be done for this key event. See `gtk_im_context_filter_keypress()`.

Note that you are expected to call this function from your handler when overriding key event handling. This is needed in the case when you need to insert your own key handling between the input method and the default key event handling of the GtkTextView.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14

    static gboolean
    gtk_foo_bar_key_press_event (GtkWidget   *widget,
                                 GdkEventKey *event)
    {
      if ((key->keyval == GDK_KEY_Return || key->keyval == GDK_KEY_KP_Enter))
        {
          if (gtk_text_view_im_context_filter_keypress (GTK_TEXT_VIEW (view), event))
            return TRUE;
        }

        // Do some stuff

      return GTK_WIDGET_CLASS (gtk_foo_bar_parent_class)->key_press_event (widget, event);
    }

#### Parameters

text_view | a GtkTextView |
event | the key event |

#### Returns

`TRUE` if the input method handled the key event.

Since: 2.22

### gtk_text_view_reset_im_context ()

    void
    gtk_text_view_reset_im_context (GtkTextView *text_view);

Reset the input method context of the text view if needed.

This can be necessary in the case where modifying the buffer would confuse on-going input method behavior.

#### Parameters

text_view | a GtkTextView |

Since: 2.22

### gtk_text_view_set_input_purpose ()

    void
    gtk_text_view_set_input_purpose (GtkTextView *text_view,
                                     GtkInputPurpose purpose);

Sets the “input-purpose” property which can be used by on-screen keyboards and other input methods to adjust their behaviour.

#### Parameters

text_view | a GtkTextView |
purpose | the purpose |

Since: 3.6

### gtk_text_view_get_input_purpose ()

    GtkInputPurpose
    gtk_text_view_get_input_purpose (GtkTextView *text_view);

Gets the value of the “input-purpose” property.

#### Parameters

text_view | a GtkTextView |

Since: 3.6

### gtk_text_view_set_input_hints ()

    void
    gtk_text_view_set_input_hints (GtkTextView *text_view,
                                   GtkInputHints hints);

Sets the “input-hints” property, which allows input methods to fine-tune their behaviour.

#### Parameters

text_view | a GtkTextView |
hints | the hints |

Since: 3.6

### gtk_text_view_get_input_hints ()

    GtkInputHints
    gtk_text_view_get_input_hints (GtkTextView *text_view);

Gets the value of the “input-hints” property.

#### Parameters

text_view | a GtkTextView |

Since: 3.6

### gtk_text_view_set_monospace ()

    void
    gtk_text_view_set_monospace (GtkTextView *text_view,
                                 gboolean monospace);

Sets the “monospace” property, which indicates that the text view should use monospace fonts.

#### Parameters

text_view | a GtkTextView |
monospace | `TRUE` to request monospace styling |

Since: 3.16

### gtk_text_view_get_monospace ()

    gboolean
    gtk_text_view_get_monospace (GtkTextView *text_view);

Gets the value of the “monospace” property.

Return: `TRUE` if monospace fonts are desired

#### Parameters

text_view | a GtkTextView |

Since: 3.16

## Types and Values

### struct GtkTextView

    struct GtkTextView;

### struct GtkTextViewClass

    struct GtkTextViewClass {
      GtkContainerClass parent_class;

      /*< public */

      void (* populate_popup)        (GtkTextView      *text_view,
                                      GtkWidget        *popup);
      void (* move_cursor)           (GtkTextView      *text_view,
                                      GtkMovementStep   step,
                                      gint              count,
                                      gboolean          extend_selection);
      void (* set_anchor)            (GtkTextView      *text_view);
      void (* insert_at_cursor)      (GtkTextView      *text_view,
                                      const gchar      *str);
      void (* delete_from_cursor)    (GtkTextView      *text_view,
                                      GtkDeleteType     type,
                                      gint              count);
      void (* backspace)             (GtkTextView      *text_view);
      void (* cut_clipboard)         (GtkTextView      *text_view);
      void (* copy_clipboard)        (GtkTextView      *text_view);
      void (* paste_clipboard)       (GtkTextView      *text_view);
      void (* toggle_overwrite)      (GtkTextView      *text_view);
      GtkTextBuffer * (* create_buffer) (GtkTextView   *text_view);
      void (* draw_layer)            (GtkTextView      *text_view,
    			          GtkTextViewLayer  layer,
    			          cairo_t          *cr);
      gboolean (* extend_selection)  (GtkTextView            *text_view,
                                      GtkTextExtendSelection  granularity,
                                      const GtkTextIter      *location,
                                      GtkTextIter            *start,
                                      GtkTextIter            *end);
    };

#### Members

`populate_popup` () | The class handler for the “populate-popup” signal. |
`move_cursor` () | The class handler for the “move-cursor” keybinding signal. |
`set_anchor` () | The class handler for the “set-anchor” keybinding signal. |
`insert_at_cursor` () | The class handler for the “insert-at-cursor” keybinding signal. |
`delete_from_cursor` () | The class handler for the “delete-from-cursor” keybinding signal. |
`backspace` () | The class handler for the “backspace” keybinding signal. |
`cut_clipboard` () | The class handler for the “cut-clipboard” keybinding signal |
`copy_clipboard` () | The class handler for the “copy-clipboard” keybinding signal. |
`paste_clipboard` () | The class handler for the “paste-clipboard” keybinding signal. |
`toggle_overwrite` () | The class handler for the “toggle-overwrite” keybinding signal. |
`create_buffer` () | The create_buffer vfunc is called to create a GtkTextBuffer for the text view. The default implementation is to just call `gtk_text_buffer_new()`. Since: 3.10 |
`draw_layer` () | The draw_layer vfunc is called before and after the text view is drawing its own text. Applications can override this vfunc in a subclass to draw customized content underneath or above the text. Since: 3.14 |
`extend_selection` () | The class handler for the “extend-selection” signal. Since 3.16 |

### enum GtkTextViewLayer

Used to reference the layers of GtkTextView for the purpose of customized drawing with the ::draw_layer vfunc.

#### Members

GTK_TEXT_VIEW_LAYER_BELOW | The layer rendered below the text (but above the background). |
GTK_TEXT_VIEW_LAYER_ABOVE | The layer rendered above the text. |

### enum GtkTextWindowType

Used to reference the parts of GtkTextView.

#### Members

GTK_TEXT_WINDOW_WIDGET | Window that floats over scrolling areas. |
GTK_TEXT_WINDOW_TEXT | Scrollable text window. |
GTK_TEXT_WINDOW_LEFT | Left side border window. |
GTK_TEXT_WINDOW_RIGHT | Right side border window. |
GTK_TEXT_WINDOW_TOP | Top border window. |
GTK_TEXT_WINDOW_BOTTOM | Bottom border window. |

### enum GtkTextExtendSelection

Granularity types that extend the text selection. Use the “extend-selection” signal to customize the selection.

#### Members

GTK_TEXT_EXTEND_SELECTION_WORD | Selects the current word. It is triggered by a double-click for example. |
GTK_TEXT_EXTEND_SELECTION_LINE | Selects the current line. It is triggered by a triple-click for example. |

Since: 3.16

### enum GtkWrapMode

Describes a type of line wrapping.

#### Members

GTK_WRAP_NONE | do not wrap lines; just make the text area wider |
GTK_WRAP_CHAR | wrap text, breaking lines anywhere the cursor can appear (between characters, usually - if you want to be technical, between graphemes, see `pango_get_log_attrs()`) |
GTK_WRAP_WORD | wrap text, breaking lines in between words |
GTK_WRAP_WORD_CHAR | wrap text, breaking lines in between words, or if that is not enough, also between graphemes |

### struct GtkTextChildAnchor

    struct GtkTextChildAnchor;

A GtkTextChildAnchor is a spot in the buffer where child widgets can be “anchored” (inserted inline, as if they were characters). The anchor can have multiple widgets anchored, to allow for multiple views.

### GTK_TEXT_VIEW_PRIORITY_VALIDATE

    #define GTK_TEXT_VIEW_PRIORITY_VALIDATE (GDK_PRIORITY_REDRAW + 5)

The priority at which the text view validates onscreen lines in an idle job in the background.

## Property Details

### The `“accepts-tab”` property

      “accepts-tab”              gboolean

Whether Tab will result in a tab character being entered.

Flags: Read / Write

Default value: TRUE

### The `“bottom-margin”` property

      “bottom-margin”            gint

The bottom margin for text in the text view.

Note that this property is confusingly named. In CSS terms, the value set here is padding, and it is applied in addition to the padding from the theme.

Don't confuse this property with “margin-bottom”.

Flags: Read / Write

Allowed values: >= 0

Default value: 0

Since: 3.18

### The `“buffer”` property

      “buffer”                   GtkTextBuffer *

The buffer which is displayed.

Flags: Read / Write

### The `“cursor-visible”` property

      “cursor-visible”           gboolean

If the insertion cursor is shown.

Flags: Read / Write

Default value: TRUE

### The `“editable”` property

      “editable”                 gboolean

Whether the text can be modified by the user.

Flags: Read / Write

Default value: TRUE

### The `“im-module”` property

      “im-module”                gchar *

Which IM (input method) module should be used for this text_view. See GtkIMContext.

Setting this to a non-`NULL` value overrides the system-wide IM module setting. See the GtkSettings “gtk-im-module” property.

Flags: Read / Write

Default value: NULL

Since: 2.16

### The `“indent”` property

      “indent”                   gint

Amount to indent the paragraph, in pixels.

Flags: Read / Write

Default value: 0

### The `“input-hints”` property

      “input-hints”              GtkInputHints

Additional hints (beyond “input-purpose”) that allow input methods to fine-tune their behaviour.

Flags: Read / Write

Since: 3.6

### The `“input-purpose”` property

      “input-purpose”            GtkInputPurpose

The purpose of this text field.

This property can be used by on-screen keyboards and other input methods to adjust their behaviour.

Flags: Read / Write

Default value: GTK_INPUT_PURPOSE_FREE_FORM

Since: 3.6

### The `“justification”` property

      “justification”            GtkJustification

Left, right, or center justification.

Flags: Read / Write

Default value: GTK_JUSTIFY_LEFT

### The `“left-margin”` property

      “left-margin”              gint

The default left margin for text in the text view. Tags in the buffer may override the default.

Note that this property is confusingly named. In CSS terms, the value set here is padding, and it is applied in addition to the padding from the theme.

Don't confuse this property with “margin-left”.

Flags: Read / Write

Allowed values: >= 0

Default value: 0

### The `“monospace”` property

      “monospace”                gboolean

Whether to use a monospace font.

Flags: Read / Write

Default value: FALSE

### The `“overwrite”` property

      “overwrite”                gboolean

Whether entered text overwrites existing contents.

Flags: Read / Write

Default value: FALSE

### The `“pixels-above-lines”` property

      “pixels-above-lines”       gint

Pixels of blank space above paragraphs.

Flags: Read / Write

Allowed values: >= 0

Default value: 0

### The `“pixels-below-lines”` property

      “pixels-below-lines”       gint

Pixels of blank space below paragraphs.

Flags: Read / Write

Allowed values: >= 0

Default value: 0

### The `“pixels-inside-wrap”` property

      “pixels-inside-wrap”       gint

Pixels of blank space between wrapped lines in a paragraph.

Flags: Read / Write

Allowed values: >= 0

Default value: 0

### The `“populate-all”` property

      “populate-all”             gboolean

If :populate-all is `TRUE`, the “populate-popup” signal is also emitted for touch popups.

Flags: Read / Write

Default value: FALSE

Since: 3.8

### The `“right-margin”` property

      “right-margin”             gint

The default right margin for text in the text view. Tags in the buffer may override the default.

Note that this property is confusingly named. In CSS terms, the value set here is padding, and it is applied in addition to the padding from the theme.

Don't confuse this property with “margin-right”.

Flags: Read / Write

Allowed values: >= 0

Default value: 0

### The `“tabs”` property

      “tabs”                     PangoTabArray *

Custom tabs for this text.

Flags: Read / Write

### The `“top-margin”` property

      “top-margin”               gint

The top margin for text in the text view.

Note that this property is confusingly named. In CSS terms, the value set here is padding, and it is applied in addition to the padding from the theme.

Don't confuse this property with “margin-top”.

Flags: Read / Write

Allowed values: >= 0

Default value: 0

Since: 3.18

### The `“wrap-mode”` property

      “wrap-mode”                GtkWrapMode

Whether to wrap lines never, at word boundaries, or at character boundaries.

Flags: Read / Write

Default value: GTK_WRAP_NONE

## Style Property Details

### The `“error-underline-color”` style property

      “error-underline-color”    GdkColor *

Color with which to draw error-indication underlines.

Flags: Read

## Signal Details

### The `“backspace”` signal

    void
    user_function (GtkTextView *text_view,
                   gpointer     user_data)

The ::backspace signal is a keybinding signal which gets emitted when the user asks for it.

The default bindings for this signal are Backspace and Shift-Backspace.

#### Parameters

text_view | the object which received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“copy-clipboard”` signal

    void
    user_function (GtkTextView *text_view,
                   gpointer     user_data)

The ::copy-clipboard signal is a keybinding signal which gets emitted to copy the selection to the clipboard.

The default bindings for this signal are Ctrl-c and Ctrl-Insert.

#### Parameters

text_view | the object which received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“cut-clipboard”` signal

    void
    user_function (GtkTextView *text_view,
                   gpointer     user_data)

The ::cut-clipboard signal is a keybinding signal which gets emitted to cut the selection to the clipboard.

The default bindings for this signal are Ctrl-x and Shift-Delete.

#### Parameters

text_view | the object which received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“delete-from-cursor”` signal

    void
    user_function (GtkTextView  *text_view,
                   GtkDeleteType type,
                   gint          count,
                   gpointer      user_data)

The ::delete-from-cursor signal is a keybinding signal which gets emitted when the user initiates a text deletion.

If the `type` is `GTK_DELETE_CHARS`, GTK+ deletes the selection if there is one, otherwise it deletes the requested number of characters.

The default bindings for this signal are Delete for deleting a character, Ctrl-Delete for deleting a word and Ctrl-Backspace for deleting a word backwords.

#### Parameters

text_view | the object which received the signal |
type | the granularity of the deletion, as a GtkDeleteType |
count | the number of `type` units to delete |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“extend-selection”` signal

    gboolean
    user_function (GtkTextView           *text_view,
                   GtkTextExtendSelection granularity,
                   GtkTextIter           *location,
                   GtkTextIter           *start,
                   GtkTextIter           *end,
                   gpointer               user_data)

The ::extend-selection signal is emitted when the selection needs to be extended at `location` .

#### Parameters

text_view | the object which received the signal |
granularity | the granularity type |
location | the location where to extend the selection |
start | where the selection should start |
end | where the selection should end |
user_data | user data set when the signal handler was connected. |

#### Returns

`GDK_EVENT_STOP` to stop other handlers from being invoked for the event. `GDK_EVENT_PROPAGATE` to propagate the event further.

Flags: Run Last

Since: 3.16

### The `“insert-at-cursor”` signal

    void
    user_function (GtkTextView *text_view,
                   gchar       *string,
                   gpointer     user_data)

The ::insert-at-cursor signal is a keybinding signal which gets emitted when the user initiates the insertion of a fixed string at the cursor.

This signal has no default bindings.

#### Parameters

text_view | the object which received the signal |
string | the string to insert |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“move-cursor”` signal

    void
    user_function (GtkTextView    *text_view,
                   GtkMovementStep step,
                   gint            count,
                   gboolean        extend_selection,
                   gpointer        user_data)

The ::move-cursor signal is a keybinding signal which gets emitted when the user initiates a cursor movement. If the cursor is not visible in `text_view` , this signal causes the viewport to be moved instead.

Applications should not connect to it, but may emit it with `g_signal_emit_by_name()` if they need to control the cursor programmatically.

The default bindings for this signal come in two variants, the variant with the Shift modifier extends the selection, the variant without the Shift modifer does not. There are too many key combinations to list them all here.

- Arrow keys move by individual characters/lines

- Ctrl-arrow key combinations move by words/paragraphs

- Home/End keys move to the ends of the buffer

- PageUp/PageDown keys move vertically by pages

- Ctrl-PageUp/PageDown keys move horizontally by pages

#### Parameters

text_view | the object which received the signal |
step | the granularity of the move, as a GtkMovementStep |
count | the number of `step` units to move |
extend_selection | `TRUE` if the move should extend the selection |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“move-viewport”` signal

    void
    user_function (GtkTextView  *text_view,
                   GtkScrollStep step,
                   gint          count,
                   gpointer      user_data)

The ::move-viewport signal is a keybinding signal which can be bound to key combinations to allow the user to move the viewport, i.e. change what part of the text view is visible in a containing scrolled window.

There are no default bindings for this signal.

#### Parameters

text_view | the object which received the signal |
step | the granularity of the move, as a GtkMovementStep |
count | the number of `step` units to move |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“paste-clipboard”` signal

    void
    user_function (GtkTextView *text_view,
                   gpointer     user_data)

The ::paste-clipboard signal is a keybinding signal which gets emitted to paste the contents of the clipboard into the text view.

The default bindings for this signal are Ctrl-v and Shift-Insert.

#### Parameters

text_view | the object which received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“populate-popup”` signal

    void
    user_function (GtkTextView *text_view,
                   GtkWidget   *popup,
                   gpointer     user_data)

The ::populate-popup signal gets emitted before showing the context menu of the text view.

If you need to add items to the context menu, connect to this signal and append your items to the `popup` , which will be a GtkMenu in this case.

If “populate-all” is `TRUE`, this signal will also be emitted to populate touch popups. In this case, `popup` will be a different container, e.g. a GtkToolbar.

The signal handler should not make assumptions about the type of `widget` , but check whether `popup` is a GtkMenu or GtkToolbar or another kind of container.

#### Parameters

text_view | The text view on which the signal is emitted |
popup | the container that is being populated |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“preedit-changed”` signal

    void
    user_function (GtkTextView *text_view,
                   gchar       *preedit,
                   gpointer     user_data)

If an input method is used, the typed text will not immediately be committed to the buffer. So if you are interested in the text, connect to this signal.

This signal is only emitted if the text at the given position is actually editable.

#### Parameters

text_view | the object which received the signal |
preedit | the current preedit string |
user_data | user data set when the signal handler was connected. |

Flags: Action

Since: 2.20

### The `“select-all”` signal

    void
    user_function (GtkTextView *text_view,
                   gboolean     select,
                   gpointer     user_data)

The ::select-all signal is a keybinding signal which gets emitted to select or unselect the complete contents of the text view.

The default bindings for this signal are Ctrl-a and Ctrl-/ for selecting and Shift-Ctrl-a and Ctrl-\ for unselecting.

#### Parameters

text_view | the object which received the signal |
select | `TRUE` to select, `FALSE` to unselect |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“set-anchor”` signal

    void
    user_function (GtkTextView *text_view,
                   gpointer     user_data)

The ::set-anchor signal is a keybinding signal which gets emitted when the user initiates setting the "anchor" mark. The "anchor" mark gets placed at the same position as the "insert" mark.

This signal has no default bindings.

#### Parameters

text_view | the object which received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“toggle-cursor-visible”` signal

    void
    user_function (GtkTextView *text_view,
                   gpointer     user_data)

The ::toggle-cursor-visible signal is a keybinding signal which gets emitted to toggle the visibility of the cursor.

The default binding for this signal is F7.

#### Parameters

text_view | the object which received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“toggle-overwrite”` signal

    void
    user_function (GtkTextView *text_view,
                   gpointer     user_data)

The ::toggle-overwrite signal is a keybinding signal which gets emitted to toggle the overwrite mode of the text view.

The default bindings for this signal is Insert.

#### Parameters

text_view | the object which received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Action

## See Also

GtkTextBuffer, GtkTextIter